diff --git a/src/backend/access/brin/brin.c b/src/backend/access/brin/brin.c
index 360b26e..caab6d0 100644
--- a/src/backend/access/brin/brin.c
+++ b/src/backend/access/brin/brin.c
@@ -696,7 +696,7 @@ brinbuildempty(PG_FUNCTION_ARGS)
  *
  * XXX we could mark item tuples as "dirty" (when a minimum or maximum heap
  * tuple is deleted), meaning the need to re-run summarization on the affected
- * range.  Need to an extra flag in brintuples for that.
+ * range.  Would need to add an extra flag in brintuples for that.
  */
 Datum
 brinbulkdelete(PG_FUNCTION_ARGS)
diff --git a/src/include/access/brin.h b/src/include/access/brin.h
index a04a132..e72fb2d 100644
--- a/src/include/access/brin.h
+++ b/src/include/access/brin.h
@@ -22,7 +22,6 @@ extern Datum brinbuild(PG_FUNCTION_ARGS);
 extern Datum brinbuildempty(PG_FUNCTION_ARGS);
 extern Datum brininsert(PG_FUNCTION_ARGS);
 extern Datum brinbeginscan(PG_FUNCTION_ARGS);
-extern Datum bringettuple(PG_FUNCTION_ARGS);
 extern Datum bringetbitmap(PG_FUNCTION_ARGS);
 extern Datum brinrescan(PG_FUNCTION_ARGS);
 extern Datum brinendscan(PG_FUNCTION_ARGS);
@@ -30,7 +29,6 @@ extern Datum brinmarkpos(PG_FUNCTION_ARGS);
 extern Datum brinrestrpos(PG_FUNCTION_ARGS);
 extern Datum brinbulkdelete(PG_FUNCTION_ARGS);
 extern Datum brinvacuumcleanup(PG_FUNCTION_ARGS);
-extern Datum brincanreturn(PG_FUNCTION_ARGS);
 extern Datum brincostestimate(PG_FUNCTION_ARGS);
 extern Datum brinoptions(PG_FUNCTION_ARGS);
 